#--
# ucert
#
# A  Ruby library for enterprise user account certification / recertification / audit project
#
# Copyright (c)  CMBNY Risk Department
#++
require 'ucert/utils/utils'
require 'ucert/ad_tracker'
require 'ucert/t24_tracker'
require 'ucert/go_contact_tracker'
require 'ucert/fis_prime_tracker'
require 'ucert/fis_egifts_tracker'
require 'ucert/alliance_swift_tracker'
require 'ucert/citidirect_securities_tracker'
require 'ucert/jpm_access_tracker'
require 'ucert/db_direct_tracker'
require 'ucert/sage100_tracker'
require 'ucert/vpn_tracker'
require 'ucert/swift_online_tracker'
require 'ucert/check21_tracker'
require 'ucert/cmbrun_ny_tracker'
require 'ucert/mantis_tracker'
require 'ucert/audiolog_tracker'
require 'ucert/citidirect_be_tracker'
require 'ucert/stb_tracker'
require 'ucert/equinix_tracker'
require 'ucert/citrix_sharefile_tracker'
require 'ucert/aix_tracker'
require 'ucert/frb_tracker'
require 'ucert/wms_tracker'
require 'ucert/yst_tracker'
require 'ucert/madison535_tracker'
require 'ucert/bloomberg_tracker'
require 'ucert/cvm_tracker'
require 'ucert/som_tracker'
require 'ucert/adp_payroll_tracker'
require 'ucert/clear_par_tracker'

module Ucert

  NAME            = "Ucert"
  GEM             = "ucert"
  VERSION		  = File.dirname(__FILE__) + "/../version.txt"
  @verbose = false
  # Module instance variable to keep track of the DN record change in the AD
  @ad_delta = File.dirname(__FILE__) + "/../data/ad/ad_delta.txt"

  class << self
    attr_accessor :ad_delta, :verbose

  	# Simple parser for the project version file
  	def read_ver
  		ver=Hash.new
  		f=File.open(VERSION,'r')
  		f.each do |line|
  			line.chomp!
  			case line
  			when /^(\s)*#/
  				next
  			when /\=/
  				entry=line.split("=").map! {|x| x.strip}
  				ver[entry[0]]=entry[1]
  			end
  		end
  		f.close
  		return ver
  	end

  	def banner
  		ver=read_ver
  		art=""
  		string = "-"*80 + "\n" + art + "\n" + "Version: " + ver["version"] + "\tRelease Date: " + ver["date"] + "\nDesigned and developed by: " + ver["author"] + "\nEmail: " + ver["email"] + "\tLinkedIn: " + ver["linkedin"] + "\n" + "-"*80
  	end

    # To do

    private


  end
end
